#include<iostream>
#include"color3d.h"

Color3D::Color3D(float r, float g, float b, float a)
{
  color[0] = r;
  color[1] = g;
  color[2] = b;
  color[3] = a;
}

Color3D::Color3D(float r, float g, float b)
{
  color[0] = r;
  color[1] = g;
  color[2] = b;
  color[3] = 1.0;
}

Color3D::Color3D(void)
{
  color[0] = color[1] = color[2] = 0.0;
  color[3] = 1.0;
}
  
bool Color3D::operator == (Color3D &c)
{
  return ((color[0] == c.color[0]) && (color[1] == c.color[1]) && (color[2] == c.color[2]) && (color[3] == c.color[3]));
}

float Color3D::R(void) { return color[0]; }
float Color3D::G(void) { return color[1]; }
float Color3D::B(void) { return color[2]; }
float Color3D::A(void) { return color[3]; }
void Color3D::R(float r) { color[0] = r; }
void Color3D::G(float g) { color[1] = g; }
void Color3D::B(float b) { color[2] = b; }
void Color3D::A(float a) { color[3] = a; }

void Color3D::print(void)
{
  cout << '(' << color[0] << ", " << color[1] << ", " << color[2] << ", " << color[3] << ')';
}

void Color3D::println(void)
{
  cout << '(' << color[0] << ", " << color[1] << ", " << color[2] << ", " << color[3] << ")\n";
}

void Color3D::save(FILE *f)
{
  fwrite(color, sizeof(color[0]), 4, f);
}

void Color3D::load(FILE *f)
{
  fread(color, sizeof(color[0]), 4, f);
}
